#!/usr/bin/perl

#################################################################################
# This script is intended to be run as a cron file to automate the updating of  #
# individual .qmail files for use with the OdeiaVir anti-virus wrapper.  It can #
# also be run from the command line.  It is provided by Capaho International,   #
# LLC under the GPL and may be freely distributed.  Tested on Red Hat Linux 7.1 #
# and 7.2 only.  It is provided without any warranty or support of any kind     #
# whatsoever.  Use at your own risk.                                            #
#################################################################################
# OdeaVir anti-virus wrapper by Juan Carlos Castro y Castro is available at:    #
# http://virus.isverybad.org                                                    #
#################################################################################
# Capaho International, LLC -- http://www.capaho.com                            #
#################################################################################

###################### PATH INFORMATION ##########################
### Change the following path information to match your system ###
##################################################################
# The mailnames path below needs wildcards for domain and user names
$mailNames = "/var/qmail/mailnames/*/*/.qmail"; # full path to .qmail files
$odeiavir = "/usr/local/bin/odeiavir"; # full path to odeiavir command
$find = "/usr/bin/find"; # full path to find command
$fileList = "/tmp/location.txt"; # temporary file to store results of find

#########################################################################
###!!!!! BEGIN PROGRAM -- DO NOT MODIFY ANYTHING BELOW THIS LINE !!!!!###
#########################################################################

use File::Copy;

system("echo Begin Odeiavir user .qmail file check");
system("$find $mailNames -print > $fileList");
$modFiles = 0;
open(LOCATION, "< $fileList") or warn "Can't open $fileList: $!\n";
while (<LOCATION>) {
$fileLocation = $_;
chomp $fileLocation;
$oldFile = "$fileLocation";
$newFile = "$fileLocation.odeiavir";
foreach ($fileLocation) {
$checkResult = 0;
open(FILE, "< $oldFile") or warn "Can't open $oldFile: $!\n";
while (<FILE>) {
open(READFILE, "< $oldFile") or warn "Can't open $oldFile: $!\n";
while (<READFILE>) {
if ("$_" !~ /odeiavir/) {
$checkResult = 1;
makeNewOdeiavirFiles();
appendNewOdeiavirFiles();
$modFiles = 1;
}
close(READFILE) or warn "Can't close $oldFile: $!\n";
			}
close(FILE) or warn "Can't close $oldFile: $!\n";
		}
	}
}
close(LOCATION) or warn "Can't close $fileList: $!\n";
cleanUp();
if ($modFiles == 0) {
noChanges();
}
system("echo End Odeiavir user .qmail file check");

sub makeNewOdeiavirFiles {
open(NEWFILE, "> $newFile") or warn "Can't open $newFile: $!\n";
print NEWFILE "| $odeiavir\n";
close(NEWFILE) or warn "Can't close $newFile: $!\n";
}

sub appendNewOdeiavirFiles {
system("echo Inserting odeiavir command in $oldFile");
open(IN,  "< $oldFile") or warn "can't open $oldFile: $!\n";
open(OUT, ">> $newFile") or warn "can't open $newFile: $!";
$blksize = (stat IN)[11] || 16384;
while ($len = sysread IN, $buf, $blksize) {
    if (!defined $len) {
        next if $! =~ /^Interrupted/;
        die "System read error: $!\n";
    }
    $offset = 0;
    while ($len) {
        defined($written = syswrite OUT, $buf, $len, $offset) or die "System write error: $!\n";
        $len    -= $written;
        $offset += $written;
    };
}
close(IN) or warn "can't close $oldFile: $!\n";
close(OUT) or warn "can't close $newFile: $!\n";
if (! -e "$oldFile.bak") {
copy("$oldFile","$oldFile.bak") or warn "Can't copy $oldFile to $oldFile.bak: $!\n";
} else {
system("echo $oldFile.bak already exists -- will not overwrite!");
}
move("$newFile","$oldFile") or warn "Can't move $newFile to $oldFile: $!\n";
}

sub cleanUp {
if (! -e "$fileList") {
system("echo $fileList could not be found for removal during cleanup!");
} else {
unlink $fileList or warn "Can't remove $fileList during cleanup: $!\n";
	}
}

sub noChanges {
system("echo No file modifications performed during this check");
}
